<h1 align="center">piRa1n</h1>
<p align="center"><img src="https://gist.githubusercontent.com/raspberryenvoie/9266a96148dd3ae0266a3bbe39b9c4f0/raw/65aca16d3ba11776f5f28a35e6d58c122540d426/piRa1n_logo.png"></p>
<h3 align="center">Easily turn a Raspberry Pi 4 or a Banana Pi M2 Zero into a portable Checkra1n dongle.</h3>

---------

[Here](https://youtu.be/lqGb8SG-VII) is a demo of piRa1n.

# Important notes
- piRa1n only works on a Raspberry Pi 4, other versions of the RPi won't work. However, it works on a Banana Pi M2 Zero.
- Make an [iCloud/iTunes backup](https://support.apple.com/en-us/HT203977) before jailbreaking, so that you can go back if something goes wrong

# Usage
### Parts list
- a Raspberry Pi 4 with either 1GB, 2GB, 4GB or 8GB of RAM (1GB of RAM is enough and cheaper so I recommend the 1GB version) or a Banana Pi M2 Zero
- a USB to USB Type-C cable (only for the RPi 4)
- a USB to micro USB cable (only for the Banana Pi M2 Zero)
- a micro USB to USB adapter (only for the Banana Pi M2 Zero)
- a USB to lightning cable
- a power bank (For better performances, make sure it supports 5V/3A output.)
- a MicroSD Card of at least 8GB

Read the [wiki pages](https://github.com/raspberryenvoie/piRa1n/wiki) for detailed instructions.

# What's new?
Read the [changelog file](https://github.com/raspberryenvoie/piRa1n/blob/master/CHANGELOG.md).

# Credits
- The Checkra1n Team for [checkra1n](https://checkra.in)
- [u/gilshahar7](https://www.reddit.com/user/gilshahar7/) for trying piRa1n on a Banana Pi M2 Zero
- [u/justPassingThrou15](https://www.reddit.com/user/justPassingThrou15/) who gave me the idea of the "Auto recovery mode" feature
- [u/FIdelity88](https://www.reddit.com/user/FIdelity88), his Ra1nbox inspired me to use libimobile and libirecovery to create the "Auto recovery mode" feature
- [libimobiledevice](https://github.com/libimobiledevice/) for [libimobiledevice](https://github.com/libimobiledevice/libimobiledevice) and [libirecovery](https://github.com/libimobiledevice/libirecovery)
- CoolStar for [odysseyra1n](https://github.com/coolstar/Odyssey-bootstrap)
- [The Procursus Team](https://github.com/ProcursusTeam/) for [Procursus](https://github.com/ProcursusTeam/Procursus)
- [JoeyEamigh](https://github.com/JoeyEamigh) who suggested with his PR to add an option to manually enter recovery mode from CLI/piRa1n-web
